#!/usr/bin/perl
#(c) 2000, Webteacher Software, LLC
#All rights reserved.

package wtcart;
$version="1.0a";

sub configurecart {
  &::checkpass;
  &::getReportInfo;
  open(FIELDS,"<$::fieldnames") or &error("Could not open $fieldnames");
  @fieldsData=<FIELDS>;
  close FIELDS;
  @fields=();
  @types=();
  foreach (@fieldsData) {
    ($field,$type)=split(/::/);
    push(@fields,"$field\n");
    push(@types,"$type");
  };
  shift(@fields);
  chomp(@fields);
  $len=@fields;


print qq(
<HEAD><TITLE>Shopping Cart Setup Page</TITLE></HEAD>
<BODY BGCOLOR=BEIGE>
<h2 align=center>Webdata Shopping Cart</h2>
<FORM ACTION="$::cgilocation" METHOD=GET>
<B>Use this image instead of the "Add to Cart" button</B><BR>
<I>Enter a relative path or URL to an image file</I> 
<INPUT TYPE=TEXT SIZE=60  NAME="cart_image" VALUE="$::cart_image">
<BR>
<B>Send e-mail to this address upon checkout</B>
<INPUT TYPE=TEXT SIZE=40 NAME="cart_email" VALUE="$::cart_email">
<BR>
<BR><B>Which field contains the product ID?</B> );
&listfields("cart_prodID","optional");
print qq(
<BR><B>Which field contains the product name?</B> );
&listfields("cart_prodName");
print qq(
<BR><B>Which field contains the product description?</B> );
&listfields("cart_prodDesc","optional");
print qq(
<BR><B>Which field contains the product price?</B> );
&listfields("cart_prodPrice");
print qq(
<BR><B>Which field contains the product weight?</B> );
&listfields("cart_prodWeight","optional");
print qq(
<BR><B>Which field contains the "Taxable" checkbox?</B> );
&listfields("cart_prodTaxable","optional");
print qq(
<P><HR><P>
<h3>CHECKOUT</h3>

<B>Currency Symbol?</B>
<INPUT TYPE=TEXT SIZE=2 NAME="cart_currency" VALUE="$::cart_currency"><P>

<B>Which payment system would you like to use? </B>
<SELECT NAME="cart_payment">
<OPTION VALUE="storage");
print " SELECTED" if $::cart_payment eq "storage";
print qq(>Save data on this server for retrieval</OPTION>
<OPTION);
print " SELECTED" if $::cart_payment eq "Authorize Net";
print qq(>Authorize Net</OPTION>
<OPTION);
print " SELECTED" if $::cart_payment eq "Processing.Net";
print qq(>Processing.Net</OPTION>
<OPTION);
print " SELECTED" if $::cart_payment eq "CardService";
print qq(>CardService</OPTION>
<OPTION);
print " SELECTED" if $::cart_payment eq "Anacom";
print qq(>Anacom</OPTION>
<OPTION);
print " SELECTED" if $::cart_payment eq "Signio";
print qq(>Signio</OPTION>
</SELECT>
<BR>
<B>If you chose a payment service, what is your user id?</B> 
<INPUT TYPE=TEXT NAME="cart_serviceID" value="$::cart_serviceID"><BR>
<B>Payment Form URL:</B><BR>
If you chose "Save data on this server",</B> enter the <I>SECURE</I> URL to the $::cgilocation script.
<BR> --- <i>or</i> ---<BR>
If you chose to use a card processing service enter the URL to submit the final form to the service.<BR>

<INPUT TYPE=TEXT NAME="cart_secureURL" SIZE=60 value="$::cart_secureURL"><BR>

<b>Return Link:</B> <I>Some processors use a return link to send the customer <b>back</b> to a particular page on your site
after the transaction is complete.  If you use one of these services, type in the full path to the
return page below. The "Save data on this server" option will return this page when the transaction is complete..</I><br>
<INPUT TYPE=TEXT NAME="cart_returnURL" SIZE=60 value="$::cart_returnURL"><BR>
<table border=0><tr><td valign=center>
<B>Which Credit Cards do you accept?</B><BR>
<I>Control-Click on all that apply</I></td><td>
<SELECT NAME="cart_cardTypes" SIZE=5 MULTIPLE>
<OPTION);
  print " SELECTED" if $::cart_cardTypes=~/Visa/;
print qq(>Visa</OPTION>
<OPTION);
  print " SELECTED" if $::cart_cardTypes=~/MasterCard/;
print qq(>MasterCard</OPTION>
<OPTION VALUE="Amex");
  print " SELECTED" if $::cart_cardTypes=~/Amex/;
print qq(>American Express</OPTION>
<OPTION);
  print " SELECTED" if $::cart_cardTypes=~/Discover/;
print qq(>Discover</OPTION>
<OPTION VALUE="Other Cards");
  print " SELECTED" if $::cart_cardTypes=~/Other Cards/;
print qq(>Diners Club or Other Dining\/Entertainment Cards</OPTION>
</SELECT></td></tr></table>

<P><HR><P>
<H3>SHIPPING OPTIONS</H3>
<I>Please select only one option</I>
<P>
<INPUT TYPE=RADIO NAME="cart_shipCalc" VALUE="ups");
  print qq( CHECKED) if $::cart_shipCalc eq "ups";
print qq(> <B>1. Calculate UPS shipping costs by weight?</B>
<BR>
	 To use this feature, create a folder in the <TT>$::uploadsdir</TT> directory named <TT>"ups"</TT>.<BR>
Then <A HREF="http://ups.com/using/software/currentrates/rate-csv/usrates.zip">click here</A> and unzip the
usrates.zip file into the <TT>"ups"</TT> directory.<BR>
Finally, <A HREF="http://ups.com/using/software/currentrates/rates_in_us.html#zones" TARGET="new">click here</A>, enter your zip code, click 'download', and save the file as <B><TT>'homezip.csv'</TT></B> in the "ups" directory.

<P>
<INPUT TYPE=RADIO NAME="cart_shipCalc" VALUE="fedex");
  print qq( CHECKED) if $::cart_shipCalc eq "fedex";
print qq(> <B>2. Calculate FedEx shipping costs by weight?</B>
<BR>
To use this feature, create a folder in the <TT>$::uploadsdir</TT> directory named <TT>"fedex"</TT>.<BR>
Then <A HREF="http://fedex.com/us/rates/downloads/rateserv.zip">Click Here</A> and unzip the rateserv.zip
file into the <TT>"fedex"</TT> directory.<BR>
Next, <A HREF="http://fedex.com/us/rates/regionlocator/" TARGET="new">Click here</A>, enter your zip code, click "Search by Zip", then click "download this region locator chart.".  Save the file to your hard disk.<BR>
Finally, open the .rtf file you just downloaded with MS Word or Word Perfect, choose SAVE-AS, select "plain text" as the file type, and name the file "homezip.txt".  <BR>
Upload "homezip.txt" in ASCII mode to the "fedex" directory.

<P>
<INPUT TYPE=RADIO NAME="cart_shipCalc" VALUE="percentage");
  print qq( CHECKED) if $::cart_shipCalc eq "percentage";
print qq(> <B>3. If shipping cost is a percentage of the total sale:</B>
Enter the percentage here, for example: 4.25 
<INPUT TYPE=TEXT  SIZE=5 NAME="cart_shipPercent" VALUE="$::cart_shipPercent">
<P>
<INPUT TYPE=RADIO NAME="cart_shipCalc" VALUE="pricerange");
  print qq( CHECKED) if $::cart_shipCalc eq "pricerange";
print qq(> <B>4. If shipping cost depends on the price range of the total sale:</B>
Enter the range <TT>low-high</TT> followed by 1 or more spaces, and the shipping cost using numbers only.<BR>
For example: <PRE>
0-4.99   1.50
5-9.99   2.25
10-19.99 4.00</PRE>

	 <TEXTAREA NAME="cart_shipPriceRange" ROWS=8 COLS=25>$::cart_shipPriceRange</TEXTAREA>
<P><HR><P>

<H3>TAXATION</H3>

<B>Enter the 2 letter code for the State you are shipping from:</B>
<INPUT TYPE=TEXT SIZE=2 NAME="cart_homeState" VALUE="$::cart_homeState">
<P>
<B>Enter your local tax rate as a percentage.</B>  For example: 5.25 
<INPUT TYPE=TEXT SIZE=5 NAME="cart_salesTax" VALUE="$::cart_salesTax">



<P><HR><P>

<H3>HEADER AND FOOTER</H3>
<B>Header</B> 
<I>This will go at the TOP of all shopping cart pages.</I><BR>
<TEXTAREA ROWS=6 COLS=80 NAME="cart_header">$::cart_header</TEXTAREA><P>

<B>Footer</B>
<I>This will go at the BOTTOM of all shopping cart pages.</I><BR>
<TEXTAREA ROWS=3 COLS=80 NAME="cart_footer">$::cart_footer</TEXTAREA><P>

<B>Special Instructions</B>
<I>If you chose "Save data on this server", this text will go at the top
of the Payment Form.</I><BR>
<TEXTAREA ROWS=3 COLS=80 NAME="cart_specialInst">$::cart_specialInst</TEXTAREA><P>
<INPUT TYPE=SUBMIT NAME="cgifunction" VALUE="Save Cart Settings">
</FORM>
<A HREF="$::cgilocation?cgifunction=admin">Return to Administration Page</A><BR>

);
}


sub listfields {
  my $sel=eval("\$::$_[0]");
  $sel=~s/[^a-zA-Z0-9\.\-\_]//g;
  print qq(<SELECT NAME="$_[0]">);
  if ($_[1] eq "optional") {print "<OPTION>-- None --</OPTION>\n"};
  foreach(@fields) {
    $formatTest=$_;
    $formatTest=~s/[^a-zA-Z0-9\.\-\_]//g;
    print "<OPTION";
    print " SELECTED" if ($formatTest=~/^$sel$/);
    print ">$_</OPTION>\n";
  }
  print qq(</SELECT>);
}  

sub saveCartSettings {
open (FILE,"<$::reportdata") or &error('Could not open $::reportdata');
@lines=<FILE>;
close FILE;
chomp(@lines);
for ($i=0;$i<128;$i++) {
push(@newfile,"$lines[$i]\n")};
push(@newfile,"$::user_data{cart_image}\n");
push(@newfile,"$::user_data{cart_email}\n");
push(@newfile,"$::user_data{cart_prodID}\n");
push(@newfile,"$::user_data{cart_prodName}\n");
push(@newfile,"$::user_data{cart_prodDesc}\n");
push(@newfile,"$::user_data{cart_prodPrice}\n");
push(@newfile,"$::user_data{cart_prodWeight}\n");
push(@newfile,"$::user_data{cart_prodTaxable}\n");
push(@newfile,"$::user_data{cart_payment}\n");
push(@newfile,"$::user_data{cart_serviceID}\n");
push(@newfile,"$::user_data{cart_secureURL}\n");
push(@newfile,"$::user_data{cart_shipCalc}\n");
$::user_data{cart_shipPercent}=~s/[^0-9\.]//g;
push(@newfile,"$::user_data{cart_shipPercent}\n");
$::user_data{cart_shipPriceRange}=~s/[\r]//g;
$::user_data{cart_shipPriceRange}=~s/[\n]/::/g;
push(@newfile,"$::user_data{cart_shipPriceRange}\n");
push(@newfile,uc("$::user_data{cart_homeState}\n"));
$::user_data{cart_salesTax}=~s/[^0-9\.]//g;
push(@newfile,"$::user_data{cart_salesTax}\n");
push(@newfile,"$::user_data{cart_returnURL}\n");
push(@newfile,"$::user_data{cart_currency}\n");
$::user_data{cart_cardTypes}=~s/ or /,/g;
push(@newfile,"$::user_data{cart_cardTypes}\n");
$::user_data{cart_header}=~s/[\r]//g;
$::user_data{cart_header}=~s/[\n]/::/g;
push(@newfile,"$::user_data{cart_header}\n");
$::user_data{cart_footer}=~s/[\r]//g;
$::user_data{cart_footer}=~s/[\n]/::/g;
push(@newfile,"$::user_data{cart_footer}\n");
$::user_data{cart_specialInst}=~s/[\r]//g;
$::user_data{cart_specialInst}=~s/[\n]/::/g;
push(@newfile,"$::user_data{cart_specialInst}\n");
open (NEWFILE,">$::reportdata") or &error('Could not write to $::reportdata');
print NEWFILE (@newfile);
close NEWFILE;
&::getReportInfo;
&::admin;
};

sub retainSettings {
open (FILE,"<$::reportdata") or &error('Could not open $::reportdata');
@lines=<FILE>;
close FILE;
chomp(@lines);
for ($i=0;$i<128;$i++) {push(@newfile,"$lines[$i]\n")};
push(@newfile,"$::cart_image\n");
push(@newfile,"$::cart_email\n");
push(@newfile,"$::cart_prodID\n");
push(@newfile,"$::cart_prodName\n");
push(@newfile,"$::cart_prodDesc\n");
push(@newfile,"$::cart_prodPrice\n");
push(@newfile,"$::cart_prodWeight\n");
push(@newfile,"$::cart_prodTaxable\n");
push(@newfile,"$::cart_payment\n");
push(@newfile,"$::cart_serviceID\n");
push(@newfile,"$::cart_secureURL\n");
push(@newfile,"$::cart_shipCalc\n");
push(@newfile,"$::cart_shipPercent\n");
$::cart_shipPriceRange=~s/[\r]//g;
$::cart_shipPriceRange=~s/[\n]/::/g;
push(@newfile,"$::cart_shipPriceRange\n");
push(@newfile,"$::cart_homeState\n");
push(@newfile,"$::cart_salesTax\n");
push(@newfile,"$::cart_returnURL\n");
push(@newfile,"$::cart_currency\n");
push(@newfile,"$::cart_cardTypes\n");
$::cart_header=~s/[\r]//g;
$::cart_header=~s/[\n]/::/g;
push(@newfile,"$::cart_header\n");
$::cart_footer=~s/[\r]//g;
$::cart_footer=~s/[\n]/::/g;
push(@newfile,"$::cart_footer\n");
$::cart_specialInst=~s/[\r]//g;
$::cart_specialInst=~s/[\n]/::/g;
push(@newfile,"$::cart_specialInst\n");
open (NEWFILE,">$::reportdata") or &error('Could not write to $::reportdata');
print NEWFILE (@newfile);
close NEWFILE;
};

sub getcartdata {
$::cart_image=$::reportData[128];
$::cart_email=$::reportData[129];
$::cart_prodID=$::reportData[130];
$::cart_prodName=$::reportData[131];
$::cart_prodDesc=$::reportData[132];
$::cart_prodPrice=$::reportData[133];
$::cart_prodWeight=$::reportData[134];
$::cart_prodTaxable=$::reportData[135];
$::cart_payment=$::reportData[136];
$::cart_serviceID=$::reportData[137];
$::cart_secureURL=$::reportData[138];
$::cart_shipCalc=$::reportData[139];
$::cart_shipPercent=$::reportData[140];
$::cart_shipPriceRange=$::reportData[141];
$::cart_shipPriceRange=~s/::/\n/g;
$::cart_homeState=$::reportData[142];
$::cart_salesTax=$::reportData[143];
$::cart_returnURL=$::reportData[144];
$::cart_currency=$::reportData[145];
$::cart_cardTypes=$::reportData[146];
$::cart_header=$::reportData[147];
$::cart_header=~s/::/\n/g;
$::cart_footer=$::reportData[148];
$::cart_footer=~s/::/\n/g;
$::cart_specialInst=$::reportData[149];
$::cart_specialInst=~s/::/\n/g;

unless ($::cart_currency) {$::cart_currency="\$"};
}

sub footer_cart_buttons {
  $equery=&::escape($::querystring);
  print qq(<FORM NAME="cartform">
<TABLE BORDER=0 CELLSPACING=5 CELLPADDING=2>
 <TR>
  <TD valign=middle>
    You have <INPUT TYPE=TEXT SIZE=3 NAME="countbox" VALUE="0" onFocus="this.blur()"> line items in your shopping cart</FONT>
  </TD>
  <TD BGCOLOR=DARKGOLDENROD valign=middle>
    <A HREF="javascript:document.vf.cgifunction.value='viewcart';document.vf.submit()"><FONT COLOR=WHITE FACE="arial" SIZE=3 STYLE="text-decoration: none"><B>VIEW CART</B></A></FONT></TD>
  <TD BGCOLOR=DARKGOLDENROD valign=middle>
    <A HREF="javascript:document.vf.cgifunction.value='checkout';document.vf.submit()"><FONT COLOR=WHITE FACE="arial" SIZE=3 STYLE="text-decoration: none"><B>CHECK OUT</B></FONT></TD>
  <TD>
    <A HREF="javascript:emptyCart()">Empty your cart</A></TD>
  </TR>
</TABLE>
</FORM>);
}


sub emptycart {
  $cookie=&::getCookie('wtcart');
  ($cartID,$cartQty,$cartAmount,@items)=split('::',$cookie);
  unlink("$::uploadsdir\.$cartID") if -e "$::uploadsdir\.$cartID";
  $linecount=0;
  $amount=0;
  &resetCookie;
  &go_back();
}

sub savecart {
  #GET THE COOKIE
    $cookie=&::getCookie('wtcart');
    return if !$cookie;
    ($cartID,$cartQty,$cartAmount,@items)=split('::',$cookie);
    if ($cartID==0) {$cartID=&counter};
    open(FILE,">>$::uploadsdir\.$cartID") or &error('Could not open $::uploadsdir\.$cartID for writing');
    foreach (@items) {print FILE "$_\n";}
    close FILE;
    open(FILE,"<$::uploadsdir\.$cartID") or &error('Could not open $::uploadsdir\.$cartID for reading');
    @lines=<FILE>;
    close FILE;
    $amount=0;
    foreach (@lines) {
      @data=split('|');
      $amount+=($data[0]*$data[4]);
    }
    $linecount=@lines;
    &resetCookie;
    &go_back() if $::user_data{cgifunction} eq "savecart";
  }

sub resetCookie {
  print qq(
	   <SCRIPT>
	   function setCookie(name, value, expire) {
	     document.cookie = name + "=" + escape(value)
	       + ((expire == null) ? "" : ("; expires=" + expire.toGMTString()))
	     }
	   
	   now=new Date();
	   expires=new Date();
	   expires.setTime(now.getTime() + 1000*60*60*24*30); //cookie expires in 30 days
	   setCookie('wtcart','${cartID}::${linecount}::${amount}',expires);
	   </SCRIPT>
	  );

}

sub go_back {
  print qq(<META HTTP-EQUIV="expires" CONTENT="0">\n);
  if ($linecount) {
    print qq(<BODY BGCOLOR=WHITE onUnload="self.opener.isopen=0"><CENTER>
	     <font size=3><B>($::user_data{qty}) $::user_data{nam} added to cart.</font>
<TABLE BORDER=0 CELLSPACING=5 CELLPADDING=2>
<TR><TD BGCOLOR=DARKGOLDENROD><A HREF="javascript:self.opener.location=\\'$::cgilocation?cgifunction=viewcart\\';self.close()"><FONT COLOR=WHITE FACE="arial" SIZE=3 STYLE="text-decoration: none"><B>
VIEW&nbsp;CART</B></A></TD><TD BGCOLOR=DARKGOLDENROD>
<A HREF="javascript:self.opener.location=\\'$::cgilocation?cgifunction=checkout\\';self.close()"><FONT COLOR=WHITE FACE="arial" SIZE=3 STYLE="text-decoration: none"><B>
CHECK&nbsp;OUT</B></TD></TR></TABLE><A HREF="javascript:self.close()">Close this window</A></CENTER></BODY>
	    );
  } else {
    print qq(
	     <SCRIPT>self.close()</SCRIPT>
	    );
  }
}

sub resultPageScript {
  $equery=&::escape($::querystring);

print qq(
<META HTTP-EQUIV="expires" CONTENT="0">

<SCRIPT>
function cartWindow(qty,nam) {
ht=100+(Math.floor(nam.length/16)*16);
options='width=250,height='+ht+',resizable=1';
nw=window.open('','cart',options);
nw.document.write('<BODY BGCOLOR=WHITE onLoad="setTimeout(\\'self.close()\\',15000)"><CENTER>');
nw.document.write('<font size=3><B>('+qty+') '+nam+' added to cart.</font>');
nw.document.write('<TABLE BORDER=0 CELLSPACING=5 CELLPADDING=2>');
nw.document.write('<TR><TD BGCOLOR=DARKGOLDENROD><A ');
nw.document.write('HREF="javascript:self.opener.document.vf.cgifunction.value=\\'viewcart\\';self.opener.document.vf.submit();self.close()"');
nw.document.write('><FONT COLOR=WHITE FACE="arial" SIZE=3 ');
nw.document.write('STYLE="text-decoration: none"><B>');
nw.document.write('VIEW&nbsp;CART</B></A></TD><TD BGCOLOR=DARKGOLDENROD>');
nw.document.write('<A HREF="javascript:self.opener.document.vf.cgifunction.value=\\'checkout\\';self.opener.document.vf.submit();self.close()"');
nw.document.write('><FONT COLOR=WHITE FACE="arial" SIZE=3 ');
nw.document.write('STYLE="text-decoration: none"><B>');
nw.document.write('CHECK&nbsp;OUT</B></TD></TR></TABLE><A HREF="javascript:self.close()">Close this window</A></CENTER></BODY>');
nw.document.close();
nw.focus();
}

function emptyCart() {
  nw=window.open('','cart','width=250,height=72,status=1');
  nw.document.write('<B>Connecting to Server.<BR>One moment please...</B>');
  nw.document.close();
  nw.location="$::cgilocation\?cgifunction=emptycart";
  document.cartform.countbox.value=0;
  sc=setTimeout('nw.close()',15000);      
}

function cartCount(n) {
  var val,cookie,pos,pos2,pos3,line,savedID,count,savedCount,savedAmount,prodID,prodName;
  var prodDesc,prodPrice,prodWeight,prodTaxable,totalSale;
  val=getCookie('wtcart');

  if (!val) {val="0::0::0"};
  count=0;
  savedID=0;
  savedCount=0;
  savedAmount=0;
  pos=val.indexOf('::');
  savedID=parseInt(val.substring(0,pos));
  val=val.substring(pos+2,val.length);
  pos=val.indexOf('::');
  savedCount=parseInt(val.substring(0,pos));
  val=val.substring(pos+2,val.length);
  pos=val.indexOf('::');
  savedAmount=parseInt(val.substring(0,pos));
  val=val.substring(pos+2,val.length);
  count=savedCount;

  if (pos==-1) {val=""} else {
      val=val.substring(pos+2,val.length);
  }

  while (val.length) {
    pos=val.indexOf('::');
    if (pos==-1) {val=""} else {
      val=val.substring(pos+2,val.length);
    }
    pos2=val.indexOf('::');
    if (pos2==-1) {pos2=val.length};
    line=val.substring(0,pos2);
    pos3=line.indexOf('|');
    prodQty=parseInt(line.substring(0,pos3));
    line=line.substring(pos3+1,line.length);
    pos3=line.indexOf('|');
    prodID=line.substring(0,pos3);
    line=line.substring(pos3+1,line.length);
    pos3=line.indexOf('|');
    prodName==line.substring(0,pos3);
    line=line.substring(pos3+1,line.length);
    pos3=line.indexOf('|');
    prodDesc=line.substring(0,pos3);
    line=line.substring(pos3+1,line.length);
    pos3=line.indexOf('|');
    prodPrice=parseFloat(line.substring(0,pos3));
    line=line.substring(pos3+1,line.length);
    pos3=line.indexOf('|');
    prodWeight=parseFloat(line.substring(0,pos3));
    line=line.substring(pos3+1,line.length);
    pos3=line.indexOf('|');
    prodTaxable=line.substring(0,pos3);
    line=line.substring(pos3+1,line.length);
    count++;
    totalSale+=prodPrice*prodQty;
  }
  return parseInt(count);
}


function addToCart(f) {
  var prodid,qty,nam,desc,price,weight,taxable,string
  prodid=f.ProdID.value;
  qty=f.cart_quantity.value;
  nam=f.Name.value;
  desc=f.Desc.value;
  price=f.Price.value;
  weight=f.Weight.value;
  taxable=f.Taxable.value;
  formlength=f.elements.length;
); 
	if ($::cart_image) {$fnum=1} else {$fnum=2};
print qq(
  for (i=6;i<formlength-$fnum;i++) {
    s=f.elements[i];
    if (s.options[s.selectedIndex].value) {
      price=parseFloat(price)+parseFloat(s.options[s.selectedIndex].value);
      desc+=" - "+s.options[s.selectedIndex].text;
    } else {
      desc+=" - "+s.options[s.selectedIndex].text;
    }
  }
  string=""+prodid+"|"+nam+"|"+desc+"|"+price+"|"+weight+"|"+taxable;
  var oldcart,newcart,len;
  oldcart=getCookie('wtcart');
  if (!oldcart) {oldcart="0::0::0"};
  newcart=""+oldcart+"::"+qty+'|'+string;
  now=new Date();
  expires=new Date();
  expires.setTime(now.getTime() + 1000*60*60*24*30); //cookie expires in 30 days
  setCookie('wtcart',newcart,expires);
  cartWindow(qty,nam);
  document.cartform.countbox.value=cartCount();
  len=cartCount();
  if ((len)&&(len/10==Math.floor(len/10))) {
    nw.document.write('<B>Connecting to Server.<BR>One moment please...</B>');
    nw.document.close();
	eqty=escape(qty);
	enam=escape(nam);
    nw.location="$::cgilocation\?cgifunction=savecart&qty="+eqty+"&nam="+enam;
  };
}


function setCookie(name, value, expire) {
   document.cookie = name + "=" + escape(value)
   + ((expire == null) ? "" : ("; expires=" + expire.toGMTString()))
}

function getCookie(Name) {
   var search = Name + "="
   if (document.cookie.length > 0) { // if there are any cookies
      offset = document.cookie.indexOf(search) 
      if (offset != -1) { // if cookie exists 
         offset += search.length 
         // set index of beginning of value
         end = document.cookie.indexOf(";", offset) 
         // set index of end of cookie value
         if (end == -1) 
            end = document.cookie.length
         return unescape(document.cookie.substring(offset, end))
      } 
   }
}
</SCRIPT>
<BODY onLoad="document.cartform.countbox.value=cartCount()">
);
}

sub addButton {
  $formname=$_[0];
  $formview=1 if $formname eq "FORM";
  my @variances;
  for ($i=0;$i<=$#::fields;$i++) {
    $prodID=$::data[$i] if $::fields[$i] eq $::cart_prodID;
    $Name=$::data[$i] if $::fields[$i] eq $::cart_prodName;
    $Desc=$::data[$i] if $::fields[$i] eq $::cart_prodDesc;
    $Price=$::data[$i] if $::fields[$i] eq $::cart_prodPrice;
    $Price=~s/[^0-9\.]//g;
    $Weight=$::data[$i] if $::fields[$i] eq $::cart_prodWeight;
    $Weight=~s/[^0-9\.]//g;
    $Taxable=$::data[$i] if $::fields[$i] eq $::cart_prodTaxable;
    &::gettype($::types[$i]);  
    if (($formview)&&($::data[$i] eq '&nbsp;')) {$::data[$i]=0};
    push(@variances,$i) if ($::type=~/variance/)&&($::data[$i]);
  }

  my $result=qq(<INPUT TYPE=HIDDEN NAME="ProdID" VALUE="$prodID">);
  $result.=qq(<INPUT TYPE=HIDDEN NAME="Name" VALUE="$Name">);
  $result.=qq(<INPUT TYPE=HIDDEN NAME="Desc" VALUE="$Desc">);
  $result.=qq(<INPUT TYPE=HIDDEN NAME="Price" VALUE="$Price">);
  $result.=qq(<INPUT TYPE=HIDDEN NAME="Weight" VALUE="$Weight">);
  $result.=qq(<INPUT TYPE=HIDDEN NAME="Taxable" VALUE="$Taxable">);
  $vcount=0;
  foreach(@variances) {
    &::gettype($::types[$_]);
    @var=split(',',$::data[$_]);
	next unless ((($#var>=0) and ($::type eq "variance")) or (($#var>=1) and ($::type="price-variance")));
    $result.=qq($::fields[$_] <SELECT NAME="$::fields[$_]">\n);
    if ($::type eq "variance") {
      foreach (@var) {
		$_=~s/^ *| *$//g;
		$result.=qq(<OPTION>$_</OPTION>);
      }
    } elsif ($::type eq "price-variance") {
      for ($v=0;$v<$#var;$v+=2) {
		$result.=qq(<OPTION VALUE="$var[$v+1]">$var[$v] - $var[$v+1]</OPTION>\n);
      }
    }
    $result.=qq(</SELECT> );
	$vcount++;
  };
  $result.=qq(<INPUT TYPE=TEXT SIZE=4 NAME="cart_quantity" VALUE=1>);

  if (length($::cart_image)) {
    $result.=qq(
<A HREF="javascript:addToCart(document.$formname)"><IMG SRC="$::cart_image" border=0 ALT="Add to cart"></A>);
  } else {
    $result.=qq(<INPUT TYPE=BUTTON NAME="cart_add" VALUE="Add to cart" onClick="addToCart(document.$formname)">);
  }
  return ($result);
}

sub viewcart {
  &savecart;
  print qq(
<HEAD><TITLE>View Shopping Cart Page</TITLE>
<SCRIPT>
function checkout() {
  document.cartform.checkout.value=1;
  document.cartform.submit();
}
</SCRIPT>
<BODY BGCOLOR=WHITE>
$::cart_header
The contents of your shopping cart is listed below.  You may change the quantity of items for any item by changing the number in the quanity box and clicking "REFRESH".  To remove an item from your order, change the quantity to zero (0) and click "REFRESH". 
<FORM NAME="cartform" ACTION="$::cgilocation" METHOD=POST>
<INPUT TYPE=HIDDEN NAME="cgifunction" VALUE="refreshcart">
<INPUT TYPE=HIDDEN NAME="query" VALUE="$::user_data{query}">
<INPUT TYPE=HIDDEN NAME="checkout" VALUE="0">
<CENTER>
<TABLE BORDER=4 CELLPADDING=0><TR><TD>
<TABLE BORDER=0 CELLPADDING=5><TR><TD BGCOLOR=DARKGOLDENROD ALIGN=CENTER><FONT COLOR=WHITE FACE=ARIAL><B>ORDER CONFIRMATION</B></FONT>
</TD></TR><TR><TD ALIGN=CENTER>);

if ($#lines>=0) {
print qq(
<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=5>
<TR>
<TH>Quantity</TH>
<TH>Product ID</TH>
<TH>Name</TH>
<TH>Description</TH>
<TH>Price</TH>
<TH>Item Total</TH>
</TR>
	  );
  chomp(@lines);
  $count=0;
  $ordertotal=0;
  foreach (@lines) {
    @data=split('\|');
    foreach (@data) {$_=~s/^$/\&nbsp\;/};
    $linetotal=$data[0]*$data[4];
    $ordertotal+=$linetotal;
	$data[3]=~s/ - [\d\.]+//g;
    if ($count%2) {print qq(<TR BGCOLOR=WHITE>)} else {print qq(<TR BGCOLOR="#FFFFEF">)};
    print qq(
<TD><INPUT TYPE=TEXT NAME="qty_$count" SIZE=4 VALUE="$data[0]"></TD>
<TD ALIGN=CENTER>$data[1]</TD>
<TD ALIGN=LEFT>$data[2]</TD>
<TD ALIGN=LEFT>$data[3]</TD>);
printf ("<TD ALIGN=RIGHT>%.2f</TD><TD ALIGN=RIGHT>%.2f</TD></TR>",$data[4],$linetotal);
    $count++;

  };
  print qq(</TABLE>);
  
  } else {print qq(<font size=+2 color=red>The Shopping Cart is Empty</font>)}
  
  print qq(</TD></TR></TABLE></TD></TR></TABLE></CENTER></FORM>);
  printf ("<CENTER>Order Total: <B>$::cart_currency%.2f</B></CENTER>",$ordertotal);
  unless ($::user_data{query}) {$::user_data{query}="cgifunction=user"};
  print qq(
<P><CENTER><TABLE BORDER=0 CELLSPACING=5 CELLPADDING=2>
<TR><TD BGCOLOR=DARKGOLDENROD><A HREF="$::cgilocation?$::user_data{query}"><FONT COLOR=WHITE FACE="arial" SIZE=3 STYLE="text-decoration: none"><B>
&lt;--&nbsp;BACK&nbsp;TO&nbsp;SHOPPING</B></A></TD>);

if ($#lines>=0) {
print qq(<TD BGCOLOR=DARKGOLDENROD><A HREF="javascript:document.cartform.submit()"><FONT COLOR=WHITE FACE="arial" SIZE=3 STYLE="text-decoration: none"><B>
REFRESH</B></A></TD><TD BGCOLOR=DARKGOLDENROD>
<A HREF="javascript:checkout()"><FONT COLOR=WHITE FACE="arial" SIZE=3 STYLE="text-decoration: none"><B>
CHECK&nbsp;OUT&nbsp;--&gt;</B></TD>);
}
print qq(</TR></TABLE></CENTER>$::cart_footer);

}

sub refreshcart {
  $cookie=&::getCookie('wtcart');
  return if !$cookie;
  ($cartID,$cartQty,$cartAmount,@items)=split('::',$cookie);
  open(FILE,"<$::uploadsdir\.$cartID") or &error('Could not open $::uploadsdir\.$cartID for reading');
  @lines=<FILE>;
  close FILE;
  for ($i=0;$i<=$#lines;$i++) {
    @data=split('\|',$lines[$i]);
    $key="qty_$i";
    if ($::user_data{$key}>0) {
      $data[0]=$::user_data{$key};
      $newline=join('|',@data);
      push(@newcart,$newline);
    }
  }
  open(FILE,">$::uploadsdir\.$cartID") or &error('Could not open $::uploadsdir\.$cartID for writing');
  print FILE (@newcart);
  close FILE;
  if ($::user_data{checkout}) {&checkout} else {&viewcart};
}

sub counter {
  &::putlock;
  if (! -e "$::uploadsdir\.counter") {
    open (COUNT,">$::uploadsdir\.counter") or &::error('Could not write initial .counter file');
    print COUNT ("0");
    close COUNT;
  }
  open (COUNT,"<$::uploadsdir\.counter") or &::error('Could not open .counter file');
  $counter=<COUNT>;
  close COUNT;
  $counter++;
  open (COUNT,">$::uploadsdir\.counter") or &::error('Could not write initial .counter file');
  print COUNT ("$counter");
  close COUNT;
  &::removelock;
  return $counter; 
}

sub validate {
#Based on the Business::CreditCard module by Jon Orwant
    my ($number) = @_;
    my ($i, $sum, $weight);
 
    return 0 if $number =~ /[^\d\s]/;
 
    $number =~ s/\D//g;
 
    return 0 unless length($number) >= 13 && 0+$number;
 
    for ($i = 0; $i < length($number) - 1; $i++) {
        $weight = substr($number, -1 * ($i + 2), 1) * (2 - ($i % 2));
        $sum += (($weight < 10) ? $weight : ($weight - 9));
    }
 
    return 1 if substr($number, -1) == (10 - $sum % 10) % 10;
    return 0;
} 

sub cardtype {
#Based on the Business::CreditCard module by Jon Orwant
    my ($number) = @_;
 
    return "Not a credit card" if $number =~ /[^\d\s]/;
 
    $number =~ s/\D//g;
 
    return "Not a credit card" unless length($number) >= 13 && 0+$number;
 
    return "VISA card" if substr($number,0,1) == "4";
    return "MasterCard" if substr($number,0,1) == "5";
    return "Discover card" if substr($number,0,1) == "6";
    return "American Express card" if substr($number,0,2) == "37";
    return "Diners Club, Transmedia, or other dining/entertainment card" if substr($number,0,1) == "3";
    return "Unknown";
}                                                                                                                 

sub process {
  unless (-d ".final") {
    print qq(<h1>Configure the storage directory</h1>
Webdata will now help you create a directory structure which is secure from
prying eyes both inside and outside of your server.<P>

<OL>
<LI> Create a directory named "<B><TT>.final</TT></B>" (yes, it should begin with a dot) inside the same directory as this script. <P>

<LI> Temporarally give the <B><TT>.final</TT></B> directory full read/write/execute permissions for everyone (<TT>chmod 777 .final</TT>). <P>

<LI> Refresh this page.
</OL>
	    );
    exit;
  }
  if ($O!~/win/i) {
    $isUnix=1;
    $slash='/';
  } else {
    $isUnix=0;
    $slash='\\';
  }
  eval($::mdir);
  unless (-e "$dir") {
    mkdir($dir,0700) or &::error('<h1>Permissions Error</h1>Could not create a directory
inside
<B><TT>.final</B></TT>. Check that the permissions of <B><TT>.final</TT></B> are set to
777');
    print qq(<H1>Storage Directory Complete</H1>
You should now change the permissions of the <B><TT>.final</TT></B> directory to allow
only yourself to read, write, or execute, and public can only execute (<TT>chmod 701
.final</TT>)<P>Refresh this page again to save your first cart.
	    );
    exit;
  }
  $cartID=$::user_data{cartID};
  unless ($cartID) {&::error('invalid cart number')};
  if (($::cart_payment eq "storage") && (!&validate($::user_data{creditcard}))) {&::error('Invalid Credit Card Number')};
  open(FILE,"<$::uploadsdir\.$cartID") or &error('Could not open $::uploadsdir\.$cartID for reading');
  @lines=<FILE>;
  close FILE;
  $::user_data{card_type}=&cardtype($::user_data{creditcard});
  $ct=substr($::user_data{card_type},0,4);
  $ct=~s/Amer/Amex/i;
  $ct=~s/Dine/Othe/i;
  if ($::cart_cardTypes!~/$ct/i) {
    print qq(
<SCRIPT>
alert('Invalid Card Type.\\nYou entered a card of type: $::user_data{card_type}.\\nWe accept: $::cart_cardTypes');
history.back();
</SCRIPT>
);
exit;
  }
    print qq(
	   <SCRIPT>
	   function setCookie(name, value, expire) {
	     document.cookie = name + "=" + escape(value)
	       + ((expire == null) ? "" : ("; expires=" + expire.toGMTString()))
	     }
	   
	   now=new Date();
	   expires=new Date();
	   expires.setTime(now.getTime() + 1000*60*60*24*365); //cookie expires in 1 year
	   </SCRIPT>
	    );

  foreach (qw(name company address1 address2 city state tel fax email billing_name billing_company billing_address1 billing_address2 billing_city billing_state billing_zipcode billing_country billing_tel)) {
    push(@tmp,$::user_data{$_});
  }
  $cart_addressinfo=join('|',@tmp);
  print qq(<SCRIPT>setCookie('cart_addressinfo','$cart_addressinfo',expires)</SCRIPT>);

  open(FILE,">$dir${slash}$cartID") or &::error('error writing to disk');
  @times=localtime(time());
  print FILE "Date/Time: ".($times[4]+1)."/$times[3]/".($times[5]+1900)." $times[2]:$times[1]:$times[0]\n";
  print FILE "IP: $ENV{REMOTE_ADDR}\n";
  @sequence=qw(name company address1 address2 city state zipcode tel fax email card_type creditcard expirationdate billing_name billing_company billing_address1 billing_address2 billing_city billing_state billing_zipcode billing_country billing_tel);
  foreach (@sequence) {
    printf FILE ("%15s %-s\n","$_\:",$::user_data{$_}) if $::cart_payment eq "storage";
  };
  printf FILE ("\n%6s %10s %16s %-6s %-7s %s\n",qw(Qty ProdID Name Price Total Description));
  
  for ($i=0;$i<=$#lines;$i++) {
    @data=split('\|',$lines[$i]);
    $data[3]=~s/ - [\d\.]+//g;
    $linetotal=$data[0]*$data[4];
    printf FILE ("%6s %10s %16s %5.2f %6.2f %s\n",$data[0],$data[1],$data[2],$data[4],$linetotal,$data[3]);
  }
  print FILE "\n";
  printf FILE ("%37s   %7.2f %s\n","Sub Total",$::user_data{ordertotal});
  printf FILE ("%37s   %7.2f %s\n","Tax",$::user_data{taxabletotal});
  printf FILE ("%37s   %7.2f %s\n","Shipping - $::user_data{ship_type} $::cart_shipCalc",$::user_data{shipping});
  printf FILE ("%37s   %7.2f %s\n","Grand Total",$::user_data{grandtotal});
  
  close FILE;
  if ($::cart_payment eq "storage") {
    $::cart_returnURL=$::searchPage unless $::cart_returnURL;
    print qq(
<SCRIPT>
document.cookie='wtcart=';
alert('Your order is complete.\\nThank You.');
location.replace('$::cart_returnURL');
</SCRIPT><NOSCRIPT>
Your order is complete.<BR>
<A HREF="$::cart_returnURL">Click here to continue</A></NOSCRIPT>
	    );
  } else {
	  print "<SCRIPT>self.close()</SCRIPT>";
  }

  #SEND MAIL TO ADMIN
  open (FILE,"<$dir${slash}$cartID") or &::error('Could re-open cookie file for e-mail');
  @lines=(<FILE>);
  foreach (@lines) {
    $_="" if /creditcard:|expirationdate:/;
  }
  close FILE;
  
  if (length($::cart_email)>0) {
  if ($::cart_payment eq "storage") {
    $mailheader=qq(This is an automatic message.\nThe following order has been processed \nby the $::cgilocation shopping cart.\n\n);
  } else {
	$mailheader=qq(
This is an automatic message. The following order was in cart number $cardID at the time that the user clicked final payment button.\n
When you obtain confirmation from $::cart_payment that payment has been completed, you may proceed to fill the following order.
	);
  }
  if ($^O=~/win/i) {
      open (MAIL,">$::{uploadsdir}mail.txt");
      print MAIL ($mailheader);
      print MAIL (@lines);
      close MAIL;
      $tmp=`$::sendmail $::{uploadsdir}mail.txt -s \"New Shopping Cart Order\" -t $::cart_email -q`;
    } else {
      open (MAIL,"|$::sendmail -t") or &::error("Could not open $::sendmail");
      print MAIL ("To: $::cart_email\nFrom: $::email\n");
      print MAIL ("Subject:New Shopping Cart Order\n");
      print MAIL ($mailheader);
      print MAIL ("<PRE>\n");
      print MAIL (@lines);
      print MAIL ("\n</PRE>");
      close MAIL;
    }
  }
}

sub retrieveOrders {
  print qq(<STYLE TYPE="text/css">
BR.pageEnd {page-break-after: auto}
</STYLE>\n);
  print qq(<BODY BGCOLOR=WHITE><H1>Retrieved Orders</H1>);
  if ($O!~/win/i) {
    $isUnix=1;
    $slash='/';
  } else {
    $isUnix=0;
    $slash='\\';
  }
  eval($::mdir);
  unless (-d $dir) {
    print qq(There are no orders to retrieve because the directory structure has not been created. Go through the checkout process, and the script will help you create a secure directory.);
    exit;
  };

  opendir FILES, $dir or &::error('Could not open secure directory. Check permissions.');
  @allfiles = grep !/^\.\.?$/, readdir FILES;
  closedir FILES;
  unless (@allfiles) {print "There are no orders to be retrieved.<BR>"};
  foreach (@allfiles) {
    print qq(<TABLE BORDER=0><TR><TD>);
    print "<PRE>\n";
    print "<B>Order No. $_</B>\n\n";
    open (FILE,"<$dir${slash}$_") or &::error('Error opening file $_ in secure directory.');
    print (<FILE>);
    close FILE;
    print "</PRE>";
    print qq(</TD></TR></TABLE>);
    print "<HR>\n";
    print qq(<BR CLASS="pageEnd">);
  };
  if (@allfiles) {
  print qq(
  <FORM ACTION="$::cgilocation" METHOD=POST>
<INPUT TYPE=SUBMIT NAME="cgifunction" VALUE="Delete Orders">
</FORM>);
	 }
print qq(<A HREF="$::cgilocation?cgifunction=admin">Return to administration page</A><P>);

}

sub deleteOrders{
  if ($O!~/win/i) {
    $isUnix=1;
    $slash='/';
  } else {
    $isUnix=0;
    $slash='\\';
  }
  eval($::mdir);
  unlink <$dir${slash}*>;
  print qq(<SCRIPT>alert('All orders have been removed from the server')</SCRIPT>);
  &::admin;
}

sub checkout {
$cart_zip=&::getCookie('cart_zipcode');
$cart_country=&::getCookie('cart_country');
unless ($cart_country) {$cart_country="United States"};
  &savecart;
  print qq(
<BODY BGCOLOR=WHITE>
$::cart_header
<CENTER><H2>CHECKOUT SCREEN</H2>
<B><I>Please confirm your order</I></B><P>
<TABLE BORDER=4 CELLPADDING=0><TR><TD>
<TABLE BORDER=0 CELLPADDING=5><TR><TD BGCOLOR=DARKGOLDENROD ALIGN=CENTER><FONT COLOR=WHITE FACE=ARIAL><B>ORDER CONFIRMATION</B></FONT>
</TD></TR><TR><TD ALIGN=CENTER>);
&displayCart($cartID);
print qq(</TD></TR></TABLE>);
$equery=&::escape($::user_data{query});

if ($#lines>=0) {
	print qq(
<!--<hr NOSHADE HEIGHT=4>-->

<TABLE BORDER=1 CELLPADDING=5 WIDTH=100% BGCOLOR="#FFFFEF">
<TR><TD>
<FORM NAME="cartform" ACTION=");
	if ($::cart_payment eq "storage") {
	  unless ($::cart_secureURL) {$::cart_secureURL=$::cgilocation};
	  print "$::cart_secureURL";
	} else {
	  print "$::cgilocation"
	}

	print qq(" METHOD=POST>);

	print qq(<B>Ship To: </B><BR>);
	print qq(Country <SELECT NAME="cart_country">\n);
print "<OPTION";
print " SELECTED" if $cart_country eq "Afghanistan";
print ">Afghanistan</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Albania";
print ">Albania</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Algeria";
print ">Algeria</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Andorra";
print ">Andorra</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Angola";
print ">Angola</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Antigua and Barbuda";
print ">Antigua and Barbuda</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Argentina";
print ">Argentina</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Armenia";
print ">Armenia</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Australia";
print ">Australia</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Austria";
print ">Austria</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Azerbaijan";
print ">Azerbaijan</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Bahamas";
print ">Bahamas</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Bahrain";
print ">Bahrain</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Bangladesh";
print ">Bangladesh</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Barbados";
print ">Barbados</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Belarus";
print ">Belarus</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Belgium";
print ">Belgium</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Belize";
print ">Belize</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Benin";
print ">Benin</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Bhutan";
print ">Bhutan</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Bolivia";
print ">Bolivia</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Bosnia and Herzegovina";
print ">Bosnia and Herzegovina</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Botswana";
print ">Botswana</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Brazil";
print ">Brazil</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Brunei";
print ">Brunei</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Bulgaria";
print ">Bulgaria</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Burkina Faso";
print ">Burkina Faso</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Burundi";
print ">Burundi</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Cambodia";
print ">Cambodia</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Cameroon";
print ">Cameroon</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Canada";
print ">Canada</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Cape Verde";
print ">Cape Verde</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Central African Republic";
print ">Central African Republic</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Chad";
print ">Chad</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Chile";
print ">Chile</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "China";
print ">China</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Colombia";
print ">Colombia</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Comoros";
print ">Comoros</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Congo";
print ">Congo</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Congo, Democratic Republic of";
print ">Congo</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Costa Rica";
print ">Costa Rica</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Croatia";
print ">Croatia</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Cuba";
print ">Cuba</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Cyprus";
print ">Cyprus</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Czech Republic";
print ">Czech Republic</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Cte d'Ivoire";
print ">Cte d'Ivoire</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Denmark";
print ">Denmark</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Djibouti";
print ">Djibouti</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Dominica";
print ">Dominica</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Dominican Republic";
print ">Dominican Republic</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Ecuador";
print ">Ecuador</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Egypt";
print ">Egypt</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "El Salvador";
print ">El Salvador</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Equatorial Guinea";
print ">Equatorial Guinea</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Eritrea";
print ">Eritrea</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Estonia";
print ">Estonia</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Ethiopia";
print ">Ethiopia</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Fiji";
print ">Fiji</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Finland";
print ">Finland</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "France";
print ">France</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Gabon";
print ">Gabon</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Gambia";
print ">Gambia</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Georgia";
print ">Georgia</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Germany";
print ">Germany</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Ghana";
print ">Ghana</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Greece";
print ">Greece</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Grenada";
print ">Grenada</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Guatemala";
print ">Guatemala</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Guinea";
print ">Guinea</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Guinea-Bissau";
print ">Guinea-Bissau</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Guyana";
print ">Guyana</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Haiti";
print ">Haiti</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Honduras";
print ">Honduras</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Hungary";
print ">Hungary</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Iceland";
print ">Iceland</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "India";
print ">India</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Indonesia";
print ">Indonesia</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Iran";
print ">Iran</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Iraq";
print ">Iraq</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Ireland";
print ">Ireland</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Israel";
print ">Israel</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Italy";
print ">Italy</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Jamaica";
print ">Jamaica</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Japan";
print ">Japan</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Jordan";
print ">Jordan</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Kazakhstan";
print ">Kazakhstan</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Kenya";
print ">Kenya</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Kiribati";
print ">Kiribati</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Korea, North";
print ">Korea, North</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Korea, South";
print ">Korea, South</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Kuwait";
print ">Kuwait</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Kyrgyzstan";
print ">Kyrgyzstan</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Laos";
print ">Laos</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Latvia";
print ">Latvia</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Lebanon";
print ">Lebanon</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Lesotho";
print ">Lesotho</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Liberia";
print ">Liberia</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Libya";
print ">Libya</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Liechtenstein";
print ">Liechtenstein</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Lithuania";
print ">Lithuania</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Luxembourg";
print ">Luxembourg</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Macedonia, Former Yugoslav Republic";
print ">Macedonia</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "of";
print ">of</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Madagascar";
print ">Madagascar</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Malawi";
print ">Malawi</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Malaysia";
print ">Malaysia</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Maldives";
print ">Maldives</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Mali";
print ">Mali</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Malta";
print ">Malta</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Marshall Islands";
print ">Marshall Islands</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Mauritania";
print ">Mauritania</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Mauritius";
print ">Mauritius</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Mexico";
print ">Mexico</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Micronesia, Federated States of";
print ">Micronesia</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Moldova";
print ">Moldova</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Monaco";
print ">Monaco</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Mongolia";
print ">Mongolia</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Morocco";
print ">Morocco</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Mozambique";
print ">Mozambique</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Myanmar";
print ">Myanmar</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Namibia";
print ">Namibia</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Nauru";
print ">Nauru</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Nepal";
print ">Nepal</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Netherlands";
print ">Netherlands</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "New Zealand";
print ">New Zealand</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Nicaragua";
print ">Nicaragua</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Niger";
print ">Niger</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Nigeria";
print ">Nigeria</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Norway";
print ">Norway</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Oman";
print ">Oman</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Pakistan";
print ">Pakistan</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Palau";
print ">Palau</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Panama";
print ">Panama</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Papua New Guinea";
print ">Papua New Guinea</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Paraguay";
print ">Paraguay</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Peru";
print ">Peru</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Philippines";
print ">Philippines</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Poland";
print ">Poland</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Portugal";
print ">Portugal</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Qatar";
print ">Qatar</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Romania";
print ">Romania</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Russia";
print ">Russia</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Rwanda";
print ">Rwanda</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Saint Kitts and Nevis";
print ">Saint Kitts and Nevis</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Saint Lucia";
print ">Saint Lucia</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Saint Vincent and The Grenadines";
print ">Saint Vincent/Grenadines</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Samoa";
print ">Samoa</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "San Marino";
print ">San Marino</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Sao Tome and Principe";
print ">Sao Tome and Principe</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Saudi Arabia";
print ">Saudi Arabia</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Senegal";
print ">Senegal</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Seychelles";
print ">Seychelles</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Sierra Leone";
print ">Sierra Leone</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Singapore";
print ">Singapore</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Slovakia";
print ">Slovakia</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Slovenia";
print ">Slovenia</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Solomon Islands";
print ">Solomon Islands</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Somalia";
print ">Somalia</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "South Africa";
print ">South Africa</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Spain";
print ">Spain</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Sri Lanka";
print ">Sri Lanka</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Sudan";
print ">Sudan</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Suriname";
print ">Suriname</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Swaziland";
print ">Swaziland</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Sweden";
print ">Sweden</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Switzerland";
print ">Switzerland</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Syria";
print ">Syria</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Taiwan";
print ">Taiwan</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Tajikistan";
print ">Tajikistan</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Tanzania";
print ">Tanzania</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Thailand";
print ">Thailand</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Togo";
print ">Togo</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Tonga";
print ">Tonga</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Trinidad and Tobago";
print ">Trinidad and Tobago</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Tunisia";
print ">Tunisia</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Turkey";
print ">Turkey</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Turkmenistan";
print ">Turkmenistan</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Tuvalu";
print ">Tuvalu</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Uganda";
print ">Uganda</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Ukraine";
print ">Ukraine</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "United Arab Emirates";
print ">United Arab Emirates</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "United Kingdom";
print ">United Kingdom</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "United States";
print ">United States</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Uruguay";
print ">Uruguay</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Uzbekistan";
print ">Uzbekistan</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Vanuatu";
print ">Vanuatu</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Vatican City";
print ">Vatican City</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Venezuela";
print ">Venezuela</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Vietnam";
print ">Vietnam</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Western Sahara";
print ">Western Sahara</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Yemen";
print ">Yemen</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Yugoslavia";
print ">Yugoslavia</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Zambia";
print ">Zambia</OPTION>\n";
print "<OPTION";
print " SELECTED" if $cart_country eq "Zimbabwe";
print ">Zimbabwe</OPTION>\n";
print qq(</SELECT>\n);
	print qq(Postal Code:&nbsp;<INPUT TYPE=TEXT NAME="zipcode" VALUE="$cart_zip" SIZE=11 > );
	if ($::cart_shipCalc=~/^ups|fedex$/) {
	  $label=uc($::cart_shipCalc);
	  print qq(<B>$label</B>&nbsp;<SELECT NAME="ship_type"><OPTION>Next Day</OPTION><OPTION>2 Day</OPTION><OPTION>Ground</OPTION></SELECT>\n);
	}
#	$equery=&::escape($::user_data{query});
	print qq(<INPUT TYPE=HIDDEN NAME="cgifunction" VALUE="checkout2">);
	print qq(<INPUT TYPE=HIDDEN NAME="cartID" VALUE="$cartID">);
	print qq(<INPUT TYPE=HIDDEN NAME="query" VALUE="$::user_data{query}"></FORM>);
	print qq(</TD></TR></TABLE></TD></TR></TABLE>);
} #end of "if #$lines>=0" to display only if cart is not empty.

print qq(</TD></TR></TABLE></TD></TR></TABLE>);
print qq(
<SCRIPT>
function checkzip(f) {
  if (f.cart_country.options[f.cart_country.selectedIndex].text=="United States") {
    zip=f.zipcode.value;
    zip=parseInt(zip.substring(0,5));
    if (isNaN(zip)) {
      alert("Zip Code must be numbers only.");
      return;
    }
    if (zip.length<5) {
      alert("Zip Code must be 5 digits");
      return;
    }
    if (zip==83422) {
      state=prompt("83422 services both Wyoming and Idaho.\\nPlease enter the 2 letter code for your state","ID");
      if (!state) {return};
      f.zipcode.value=""+zip+":"+state;
    }
  }
  document.cartform.submit();
}
</SCRIPT>
	);

printf("<P>Order Total <B>$::cart_currency%.2f</B><P>\n",$ordertotal);

print qq(<TABLE BORDER=0 CELLSPACING=5 CELLPADDING=2>
<TD BGCOLOR=DARKGOLDENROD><A
HREF="$::cgilocation?$::user_data{query}"><FONT
COLOR=WHITE FACE="arial" SIZE=3 STYLE="text-decoration: none"><B>
&lt;--&nbsp;BACK TO SHOPPING</B></A></TD>
);

if ($#lines>=0) {
print qq(
<TD BGCOLOR=DARKGOLDENROD><A HREF="$::cgilocation?cgifunction=viewcart&query=$equery"><FONT COLOR=WHITE FACE="arial" SIZE=3 STYLE="text-decoration: none"><B>
MAKE&nbsp;CHANGES </B></A></TD>
<TD BGCOLOR=DARKGOLDENROD>
<A HREF="javascript:checkzip(document.cartform)"><FONT COLOR=WHITE FACE="arial" SIZE=3 STYLE="text-decoration: none"><B>
PROCEED&nbsp;WITH&nbsp;CHECK&nbsp;OUT&nbsp;--&gt;</B></TD>);
}

print qq(</TR>);
print qq(</TD></TR></TABLE>);
print qq(</CENTER>$::cart_footer);

}

sub displayCart {
  if ($_[0]) {
    $cartID=$_[0]
  } else {
    $cookie=&::getCookie('wtcart');
    return if !$cookie;
    ($cartID,$cartQty,$cartAmount,@items)=split('::',$cookie);
  }
  open(FILE,"<$::uploadsdir\.$cartID") or &error('Could not open $::uploadsdir\.$cartID for reading');
  @lines=<FILE>;
  close FILE;
  if ($#lines<0) {print qq(<font color=red size=+2>The Shopping Cart is Empty</font>);return};
  $ordertotal=0;
  print qq(<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=5>
<TR>
<TH>Qty</TH>
<TH>Prod ID</TH>
<TH>Name</TH>
<TH>Description</TH>
<TH>Price</TH>
<TH>Item Total</TH></TR>
);
  for ($i=0;$i<=$#lines;$i++) {
    @data=split('\|',$lines[$i]);
	  $data[3]=~s/ - [\d\.]+//g;
    print qq(<TR>
<TD ALIGN=RIGHT><TT>$data[0]</TT></TD>
<TD><TT>$data[1]</TT></TD>
<TD><TT>$data[2]</TT></TD>
<TD><TT>$data[3]</TT></TD>
<TD ALIGN=RIGHT><TT>);
    $linetotal=$data[0]*$data[4];
    printf("%.2f</TT></TD><TD ALIGN=RIGHT><TT>%.2f",$data[4],$linetotal);
    
    $ordertotal+=$linetotal;
    $taxabletotal+=$linetotal if $data[6];
    unless ($data[5]) {$data[5]=0};
    $weighttotal+=$data[0]*$data[5];


    print qq(</TT></TD></TR>);
    
  }
  print qq(</TABLE>);
  
};

sub round {
  unless ($#_==1) {&::error('ERROR with round. USAGE: \&round(value,places) ex. \&round(6.544553,2)')}
  my ($val,$place)=@_;
  $val=$val*(10**$place);
  $val++ if $val-int($val)>=0.5;
  $val=int($val)/(10**$place);
  return $val;
}


############################################################################
#####  END FREE DEMO CODE ##################################################
############################################################################


sub checkout2 {
  $cartID=$::user_data{cartID};
  print qq(<BODY BGCOLOR=WHITE>$::cart_header);

#CHECK FOR REQUIRED STATE AND ZIP
  $errormsg="";
  if ($::user_data{zipcode}!~/[a-zA-Z0-9]/) {
    $errormsg.="A Postal Code is required.<BR>";
  }
 &makeZipList;
 $zipPrefix=substr($::user_data{zipcode},0,3);
  if ($::user_data{cart_country} eq "United States") {
    if (exists($zipExceptions{substr($::user_data{zipcode},0,5)})) {
      $state=$zipExceptions{substr($::user_data{zipcode},0,5)};
      if (substr($::user_data{zipcode},0,5)==83422) {
	if ($::user_data{zipcode}=~/ID/) {
	  $state="ID";
	} else {
	  $state="WY";
	}
	$::user_data{zipcode}=substr($::user_data{zipcode},0,5);
      }
    } else {
      $state=$zipState{$zipPrefix};
    }
  }
  
  if (length($errormsg)) {
    print qq(The checkout script cannot continue for the following reasons:<P>);
    print qq($errormsg\n);
    print qq(<A HREF="javascript:history.back()">Return to previous page</A>);
    exit;
  }
#DISPLAY CART
  open(FILE,"<$::uploadsdir\.$cartID") or &error('Could not open $::uploadsdir\.$cartID for reading');
  @lines=<FILE>;
  close FILE;
  $ordertotal=0;
  $weighttotal=0;
  $taxabletotal=0;
print qq(<BODY BGCOLOR=WHITE>
<CENTER><H2>CHECKOUT SCREEN</H2>
<B><I>Please confirm your order</I></B><P>
<TABLE BORDER=4 CELLPADDING=0><TR><TD>
<TABLE BORDER=0 CELLPADDING=5><TR><TD BGCOLOR=DARKGOLDENROD ALIGN=CENTER><FONT COLOR=WHITE FACE=ARIAL><B>ORDER CONFIRMATION</B></FONT>
</TD></TR><TR><TD ALIGN=CENTER>);
  &displayCart($cartID);
print qq(</TD></TR></TABLE></TD></TR></TABLE>);
  $taxabletotal=$taxabletotal*($::cart_salesTax/100);
  $taxabletotal=&round($taxabletotal,2);
  $taxabletotal=0 if $::cart_homeState ne $state;
  $shipping=getShipping($weighttotal);
  $shipping=&round($shipping,2);
  $grandtotal=$ordertotal+$taxabletotal+$shipping;
  print "<BLOCKQUOTE><PRE>\n";
  printf("%-40s%8.2f\n","<B>Order Subtotal</B>",$ordertotal);
  printf("%-40s%8.2f\n","<B>Tax</B>",$taxabletotal);
  printf("%-40s%8.2f\n","<B>Shipping</B>",$shipping);
  printf("%-39s<B>$::cart_currency%8.2f</B>\n","<B>GRAND TOTAL</B>",$grandtotal);
  print "</PRE></BLOCKQUOTE>\n";

&payment;


$equery=&::escape($::user_data{query});
 print qq(<TABLE BORDER=0 CELLSPACING=5 CELLPADDING=2>
<TD BGCOLOR=DARKGOLDENROD><A
HREF="javascript:history.back()"><FONT COLOR=WHITE
FACE="arial" SIZE=3 STYLE="text-decoration: none"><B>
&lt;--&nbsp;MAKE&nbsp;CHANGES </B></A></TD></TR></TABLE>
	);
print qq(</CENTER> $::cart_footer); 
  print qq(
	   <SCRIPT>
	   function setCookie(name, value, expire) {
	     document.cookie = name + "=" + escape(value)
	       + ((expire == null) ? "" : ("; expires=" + expire.toGMTString()))
	     }
	   
	   now=new Date();
	   expires=new Date();
	   expires.setTime(now.getTime() + 1000*60*60*24*365); //cookie expires in 1 year
		setCookie('cart_zipcode','$::user_data{zipcode}',expires);
		setCookie('cart_country','$::user_data{cart_country}',expires);
		function serviceForm(f) {
		  nw=window.open('','','width=250,height=100');
		  nw.document.write('<BODY BGCOLOR=WHITE onLoad="document.form1.submit()">');
		  nw.document.write('<B>Connecting to Server. Please wait...</B>');
		  formstring='<FORM NAME="form1" ACTION="$::cgilocation" METHOD=POST>'+
		  '<INPUT TYPE=HIDDEN NAME="cgifunction" VALUE="process order">'+
		  '<INPUT TYPE=HIDDEN NAME="ordertotal" VALUE="$ordertotal">'+
		  '<INPUT TYPE=HIDDEN NAME="taxabletotal" VALUE="$taxabletotal">'+
		  '<INPUT TYPE=HIDDEN NAME="shipping" VALUE="$shipping">'+
		  '<INPUT TYPE=HIDDEN NAME="grandtotal" VALUE="$grandtotal">'+
		  '<INPUT TYPE=HIDDEN NAME="ship_type" VALUE="$weighttotal lbs, $::user_data{ship_type}">'+
		  '<INPUT TYPE=HIDDEN NAME="cartID" VALUE="$cartID">'+
		  '</FORM>';
		  nw.document.write(formstring);
		  nw.document.close();
		  nw.location='$::cgilocation\?cgifunction=process+order&cartID=$cartID'
		  f.submit();
		}
	   </SCRIPT>
	  );

}

sub storage {
  $addressinfo=&::getCookie(cart_addressinfo);
  @addr=split('\|',$addressinfo);
  $acount=0;
  foreach (qw(name company address1 address2 city state tel fax email billing_name billing_company billing_address1 billing_address2 billing_city billing_state billing_zipcode billing_country billing_tel)) {
    $address{$_}=@addr[$acount];
    $acount++;
}
  $state=$address{state} unless $state;
 print qq(<FORM NAME="cartform" ACTION="$::cgilocation" METHOD="POST">
<P>$::cart_specialInst
<TABLE BORDER=0>
<TR><TD COLSPAN=2>&nbsp;</TD></TR>
<TR><TD ALIGN-LEFT COLSPAN=2><B><FONT SIZE=+1><U>Shipping Information</U></FONT></B></TD></TR>
<TR><TD>Name</TD><TD><INPUT TYPE=TEXT NAME="name" SIZE=40 VALUE="$address{name}"></TD></TR>
<TR><TD>Company</TD><TD><INPUT TYPE=TEXT NAME="company" SIZE=20 VALUE="$address{company}"></TD></TR>
<TR><TD>Address1</TD><TD><INPUT TYPE=TEXT NAME="address1" SIZE=25 VALUE="$address{address1}"></TD></TR>
<TR><TD>Address2</TD><TD><INPUT TYPE=TEXT NAME="address2" SIZE=25 VALUE="$address{address2}"></TD></TR>
<TR><TD>City</TD><TD><INPUT TYPE=TEXT NAME= "city" SIZE=20 VALUE="$address{city}"></TR>
<TR><TD>State/Province</TD><TD><INPUT TYPE=TEXT NAME="state" VALUE="$state"></TD></TR>
<TR><TD>Postal Code</TD><TD><INPUT TYPE=HIDDEN NAME="zipcode" VALUE="$::user_data{zipcode}">$::user_data{zipcode}</TD></TR>
<TR><TD>Country</TD><TD><INPUT TYPE=HIDDEN NAME="country" VALUE="$::user_data{cart_country}">$::user_data{cart_country}</TD></TR>
<TR><TD>Telephone</TD><TD><INPUT TYPE=TEXT NAME="tel" SIZE=20 VALUE="$address{tel}"></TD></TR>
<TR><TD>Fax</TD><TD><INPUT TYPE=TEXT NAME="fax" SIZE=20 VALUE="$address{fax}"></TD></TR>
<TR><TD>E-mail</TD><TD><INPUT TYPE=TEXT NAME="email" SIZE=35 VALUE="$address{email}"></TD></TR>
<TR><TD>Credit Card Number<BR><I>$::cart_cardTypes</I>
</TD><TD><INPUT TYPE=TEXT NAME="creditcard" SIZE=16></TD></TR>
<TR><TD>Expiration Date (mmyy)</TD><TD><INPUT TYPE=TEXT NAME="expirationdate" SIZE=4></TD></TR>

<TR><TD COLSPAN=2>&nbsp;</TD></TR>
<TR><TD ALIGN-LEFT COLSPAN=2><B><FONT SIZE=+1><U>Billing Information</U></FONT></B> <I>If Different from above</I></TD></TR>
<TR><TD>Name</TD><TD><INPUT TYPE=TEXT NAME="billing_name" SIZE=40 VALUE="$address{billing_name}"></TD></TR>
<TR><TD>Company</TD><TD><INPUT TYPE=TEXT NAME="billing_company" SIZE=20 VALUE="$address{billing_company}"></TD></TR>
<TR><TD>Address1</TD><TD><INPUT TYPE=TEXT NAME="billing_address1" SIZE=25 VALUE="$address{billing_address1}"></TD></TR>
<TR><TD>Address2</TD><TD><INPUT TYPE=TEXT NAME="billing_address2" SIZE=25 VALUE="$address{billing_address2}"></TD></TR>
<TR><TD>City</TD><TD><INPUT TYPE=TEXT NAME= "billing_city" SIZE=20 VALUE="$address{billing_city}"></TR>
<TR><TD>State/Province</TD><TD><INPUT TYPE=TEXT NAME="billing_state" VALUE="$address{billing_state}"></TD></TR>
<TR><TD>Postal Code</TD><TD><INPUT TYPE=TEXT NAME="billing_zipcode" VALUE="$address{billing_zipcode}"></TD></TR>
<TR><TD>Country</TD><TD><INPUT TYPE=TEXT NAME="billing_country" VALUE="$address{billing_country}"></TD></TR>
<TR><TD>Telephone</TD><TD><INPUT TYPE=TEXT NAME="billing_tel" SIZE=20 VALUE="$address{billing_tel}"></TD></TR>
</TABLE>

<INPUT TYPE=HIDDEN NAME="cgifunction" VALUE="process order">
<INPUT TYPE=HIDDEN NAME="ordertotal" VALUE="$ordertotal">
<INPUT TYPE=HIDDEN NAME="taxabletotal" VALUE="$taxabletotal">
<INPUT TYPE=HIDDEN NAME="shipping" VALUE="$shipping">
<INPUT TYPE=HIDDEN NAME="grandtotal" VALUE="$grandtotal">
<INPUT TYPE=HIDDEN NAME="ship_type" VALUE="$weighttotal lbs, $::user_data{ship_type}">
<INPUT TYPE=HIDDEN NAME="cartID" VALUE="$cartID">
<INPUT TYPE=SUBMIT VALUE="Complete my purchase">
</FORM>
 );
}

sub authorizenet {
  print qq(<FORM METHOD=POST ACTION="$::cart_secureURL">
<input type="hidden" name="x_Login" value="$::cart_serviceID">
<input type="hidden" name="x_Description" value="Shopping Cart Order #$cartID" SIZE=80><P>
<input type="hidden" name="x_Amount" value=");
printf ("%.2f",$grandtotal);
print qq(">
<input type="hidden" name="x_Cust_ID" value="Shopping Cart Customer">
<input type="hidden" name="x_zip" value="$::user_data{zipcode}">
<input type="hidden" name="x_Version" value="3.0">
<input type="hidden" name="x_Show_Form" value="PAYMENT_FORM">
<input type="button" value="Click Here for Secure Payment Form" onClick="serviceForm(form)">
</FORM>
);
}

sub processingnet {
  print qq(
<FORM METHOD=POST ACTION="$::cart_secureURL">
<INPUT TYPE=HIDDEN NAME="vendor" VALUE="$::cart_serviceID">
<input type="hidden" name="price" value="$grandtotal">
<input type="hidden" name="orderid" value="$cartID">
<input type="button" value="Click Here for Secure Payment Form" onClick="serviceForm(form)">
</FORM>
);
}

sub cardservice {
  print qq(
<FORM METHOD=POST ACTION="$::cart_secureURL">
<INPUT TYPE=HIDDEN NAME="mode" VALUE="fullpay">
<INPUT TYPE=HIDDEN NAME="chargetotal" VALUE="$grandtotal">
<INPUT TYPE=HIDDEN NAME="storename" VALUE="$::cart_serviceID">
<input type="button" value="Click Here for Secure Payment Form" onClick="serviceForm(form)">
</FORM>
);
}

sub anacom {
  print qq(
<FORM METHOD=POST ACTION="$::cart_secureURL">
<input type="hidden" name="returnlink" value="$::cart_returnURL">
<input type="hidden" name="fulltotal" value="$grandtotal">
<input type="hidden" name="ordernumber" value="$cartID">
<input type="hidden" name="bzip" value="$::user_data{zipcode}">
<input type="button" value="Click Here for Secure Payment Form" onClick="serviceForm(form)">
</FORM>
);
}

sub signio {
  #default link: https://payflowlink.signio.com/paylinks.dll
  print qq(
<form method="POST" action="$::cart_secureURL"> 
<input type="hidden" name="MFCIsapiCommand" value="Orders"> 
<input type="hidden" name="LOGIN" value="$::cart_serviceID"> 
<input type="hidden" name="AMOUNT" value="$grandtotal"> 
<input type="hidden" name="TYPE" value="S"> 
<input type="submit" value="Click here to Purchase"> 
</form>
);
}


sub getShipping {
  $weight=$_[0];
  $zipcode=$::user_data{zipcode};
  $ship_type=$::user_data{ship_type};
  if ($::uploadsdir=~/([\\\/])/) {$slash=$1};

  if ($::cart_shipCalc eq "ups") { 
  #CALCULATE UPS RATE
  $upsdir="${::uploadsdir}ups$slash";

  open(FILE1,"<${upsdir}homezip.csv") or &::error("could not open ${upsdir}homezip.csv");
  @homezip=<FILE1>;
  close FILE1;
  chomp(@homezip);

  if ($ship_type eq "Next Day") {$ratefile="1da.csv";$upscol=6}
  elsif ($ship_type eq "2 Day") {$ratefile="2da.csv";$upscol=3}
  else {$ratefile="gndres.csv";$upscol=1};

  open(FILE2, "<${upsdir}$ratefile") or &::error("could not open ${upsdir}$ratefile");
  @rates=<FILE2>;
  close FILE2;
  chomp(@rates);

  $zipcode=substr($zipcode,0,3);
  foreach (@homezip) {
    next if @homezip!~/^\d/;
    @data=split(',');
    $i=$data[0];
    if (($i!~/-/)&&($zipcode eq $i)) {
      $zone=$data[$upscol];
      if ($zone eq "-") {
	print qq(UPS $ship_type service is not available. Please click the back button and select another service.);
	exit;
      }
      last;
    }
    if ($i=~/-/) {
      ($min,$max)=split(/-/,$i);
      if (($min<=$zipcode)&&($max>=$zipcode)) {
	$zone=$data[$upscol];
	if ($zone eq "-") {
	  print qq(UPS $ship_type service is not available. Please click the back button and select another service.);
	  exit;
      }
	last;
      }
    }
  }
  foreach (@rates) {
    if (/^Weight/i) {
      @titles=split(',');
      $count=0;
      foreach (@titles) {
	if (/(\d+)/) {$titlenum=$1};
	if ($titlenum==$zone) {$zonecol=$count};
	$count++;
      }
    }
    if (/^\d/) {
      $_=~s/ //g;
      @data=split(',');
      next if $data[0]<$weight;
      $result=$data[$zonecol];
      last;
    }
  }
  
  return $result;
}

if ($::cart_shipCalc eq "fedex") { 
  #CALCULATE FEDEX RATE
  $fedexdir="${::uploadsdir}fedex$slash";
  %rates=();
  $nextline=0;
  $key=0;
  open(FILE1,"<${fedexdir}homezip.txt") or &::error("could not open ${fedexdir}homezip.txt");
  while (<FILE1>) {
    if (/^\d{5}/) {
      $key=$_;
      chomp($key);
    } 
    elsif ($key) {
      $val=$_;
      chomp($val);
      $rates{$key}=$val;
      $key=0;
    }
  };
  close FILE1;
  #get region
  foreach (keys %rates) {
    next unless /^\d/;
    if (/^$zipcode$/) {
      $zone=$rates{$_};
      last;
    }
    if (/\d{5}-\d{5}/) {
      ($min,$max)=split('-');
      if (($zipcode>=$min)&&($zipcode<=$max)) {
	$zone=$rates{$_};
	last;
      }
    }
  }
  
  #open correct shipping file
  if ($ship_type eq "Next Day") {$ratefile="serv-po.txt";$upscol=6}
  elsif ($ship_type eq "2 Day") {$ratefile="serv-e2.txt";$upscol=3}
  else {$ratefile="serv-exp.txt";$upscol=1};
  open(FILE2, "<${fedexdir}$ratefile") or &::error("could not open ${fedexdir}$ratefile");
  @rates=<FILE2>;
  close FILE2;
  
  #lookup region and weight
  until ($rates[0]=~/\d  +\d/) {shift(@rates)};
  @titles=split(/ +/,$rates[0]);
  chomp(@titles);
  shift(@titles);
  $count=0;
  foreach (@titles) {
    if (/([\d-]+)/) {$titlenum=$1};
    if ($titlenum==$zone) {$zonecol=$count;last};
    if ($titlenum=~/-/) {
      ($min,$max)=split('-',$titlenum);
      if (($zone>=$min)&&($zone<=$max)) {
	$zonecol=$count;
	last;
      }
    }
    $count++;
  }
  shift(@rates);
  until ($rates[0]=~/\$\d+\.\d+  +\$\d+\.\d+/) {shift(@rates)};
  if ($weight<1) {
    @prices=split(/ +/,$rates[0]);
    chomp(@prices);
    shift(@prices);
    return $prices[$zonecol];
  }
  shift(@rates);
  until ($rates[0]=~/\$\d+\.\d+  +\$\d+\.\d+/) {shift(@rates)};
  foreach (@rates) {
    last if /^ *$/;
    $_=~s/\$//g;
    $_=~s/lbs?\.//g;
    @prices=split(/ +/,$_);
    shift(@prices);

    if ($prices[0]=~/(\d+)/) {$lineWeight=$1};
    shift(@prices);
    if ($weight >= $lineWeight) {$result=$prices[$zonecol]} else {last};
  }

  return $result;

}


if ($::cart_shipCalc eq "percentage") {
  $result=($::cart_shipPercent/100)*$ordertotal;
  return $result;
} 

if ($::cart_shipCalc eq "pricerange") { 
  @prlines=split(/\n/,$::cart_shipPriceRange);
  chomp(@prlines);
  foreach (@prlines) {
    ($range,$total)=split(/ +/);
    ($min,$max)=split('-',$range);
    if (($ordertotal>=$min)&&($ordertotal<=$max)) {
      return $total;
    }
  }
  
}


}








sub makeZipList {
  %zipState=qw(
002 NH 003 VA 005 NY 006 PR 007 PR 008 VI 009 PR 010 MA 011 MA 012 MA 
013 MA 014 MA 015 MA 016 MA 017 MA 018 MA 019 MA 020 MA 021 MA 022 MA 
023 MA 024 MA 025 MA 026 MA 027 MA 028 RI 029 RI 030 NH 031 NH 032 NH 
033 NH 034 NH 035 NH 036 NH 037 NH 038 NH 039 ME 040 ME 041 ME 042 ME 
043 ME 044 ME 045 ME 046 ME 047 ME 048 ME 049 ME 050 VT 051 VT 052 VT 
053 VT 054 VT 055 MA 056 VT 057 VT 058 VT 059 VT 060 CT 061 CT 062 CT 
063 CT 064 CT 065 CT 066 CT 067 CT 068 CT 069 CT 070 NJ 071 NJ 072 NJ 
073 NJ 074 NJ 075 NJ 076 NJ 077 NJ 078 NJ 079 NJ 080 NJ 081 NJ 082 NJ 
083 NJ 084 NJ 085 NJ 086 NJ 087 NJ 088 NJ 089 NJ 090 AE 091 AE 092 AE 
093 AE 094 AE 095 AE 096 AE 097 AE 098 AE 100 NY 101 NY 102 NY 103 NY 
104 NY 105 NY 106 NY 107 NY 108 NY 109 NY 110 NY 111 NY 112 NY 113 NY 
114 NY 115 NY 116 NY 117 NY 118 NY 119 NY 120 NY 121 NY 122 NY 123 NY 
124 NY 125 NY 126 NY 127 NY 128 NY 129 NY 130 NY 131 NY 132 NY 133 NY 
134 NY 135 NY 136 NY 137 NY 138 NY 139 NY 140 NY 141 NY 142 NY 143 NY 
144 NY 145 NY 146 NY 147 NY 148 NY 149 NY 150 PA 151 PA 152 PA 153 PA 
154 PA 155 PA 156 PA 157 PA 158 PA 159 PA 160 PA 161 PA 162 PA 163 PA 
164 PA 165 PA 166 PA 167 PA 168 PA 169 PA 170 PA 171 PA 172 PA 173 PA 
174 PA 175 PA 176 PA 177 PA 178 PA 179 PA 180 PA 181 PA 182 PA 183 PA 
184 PA 185 PA 186 PA 187 PA 188 PA 189 PA 190 PA 191 PA 192 PA 193 PA 
194 PA 195 PA 196 PA 197 DE 198 DE 199 DE 200 DC 201 VA 202 DC 203 DC 
204 DC 205 DC 206 MD 207 MD 208 MD 209 MD 210 MD 211 MD 212 MD 214 MD 
215 MD 216 MD 217 MD 218 MD 219 MD 220 VA 221 VA 222 VA 223 VA 224 VA 
225 VA 226 VA 227 VA 228 VA 229 VA 230 VA 231 VA 232 VA 233 VA 234 VA 
235 VA 236 VA 237 VA 238 VA 239 VA 240 VA 241 VA 242 VA 243 VA 244 VA 
245 VA 246 VA 247 WV 248 WV 249 WV 250 WV 251 WV 252 WV 253 WV 254 WV 
255 WV 256 WV 257 WV 258 WV 259 WV 260 WV 261 WV 262 WV 263 WV 264 WV 
265 WV 266 WV 267 WV 268 WV 270 NC 271 NC 272 NC 273 NC 274 NC 275 NC 
276 NC 277 NC 278 NC 279 NC 280 NC 281 NC 282 NC 283 NC 284 NC 285 NC 
286 NC 287 NC 288 NC 289 NC 290 SC 291 SC 292 SC 293 SC 294 SC 295 SC 
296 SC 297 SC 298 SC 299 SC 300 GA 301 GA 302 GA 303 GA 304 GA 305 GA 
306 GA 307 GA 308 GA 309 GA 310 GA 311 GA 312 GA 313 GA 314 GA 315 GA 
316 GA 317 GA 318 GA 319 GA 320 FL 321 FL 322 FL 323 FL 324 FL 325 FL 
326 FL 327 FL 328 FL 329 FL 330 FL 331 FL 332 FL 333 FL 334 FL 335 FL 
336 FL 337 FL 338 FL 339 FL 340 AA 341 FL 342 FL 344 FL 346 FL 347 FL 
349 FL 350 AL 351 AL 352 AL 354 AL 355 AL 356 AL 357 AL 358 AL 359 AL 
360 AL 361 AL 362 AL 363 AL 364 AL 365 AL 366 AL 367 AL 368 AL 369 AL 
370 TN 371 TN 372 TN 373 TN 374 TN 375 TN 376 TN 377 TN 378 TN 379 TN 
380 TN 381 TN 382 TN 383 TN 384 TN 385 TN 386 MS 387 MS 388 MS 389 MS 
390 MS 391 MS 392 MS 393 MS 394 MS 395 MS 396 MS 397 MS 399 GA 400 KY 
401 KY 402 KY 403 KY 404 KY 405 KY 406 KY 407 KY 408 KY 409 KY 410 KY 
411 KY 412 KY 413 KY 414 KY 415 KY 416 KY 417 KY 418 KY 420 KY 421 KY 
422 KY 423 KY 424 KY 425 KY 426 KY 427 KY 430 OH 431 OH 432 OH 433 OH 
434 OH 435 OH 436 OH 437 OH 438 OH 439 OH 440 OH 441 OH 442 OH 443 OH 
444 OH 445 OH 446 OH 447 OH 448 OH 449 OH 450 OH 451 OH 452 OH 453 OH 
454 OH 455 OH 456 OH 457 OH 458 OH 459 OH 460 IN 461 IN 462 IN 463 IN 
464 IN 465 IN 466 IN 467 IN 468 IN 469 IN 470 IN 471 IN 472 IN 473 IN 
474 IN 475 IN 476 IN 477 IN 478 IN 479 IN 480 MI 481 MI 482 MI 483 MI 
484 MI 485 MI 486 MI 487 MI 488 MI 489 MI 490 MI 491 MI 492 MI 493 MI 
494 MI 495 MI 496 MI 497 MI 498 MI 499 MI 500 IA 501 IA 502 IA 503 IA 
504 IA 505 IA 506 IA 507 IA 508 IA 509 IA 510 IA 511 IA 512 IA 513 IA 
514 IA 515 IA 516 IA 520 IA 521 IA 522 IA 523 IA 524 IA 525 IA 526 IA 
527 IA 528 IA 530 WI 531 WI 532 WI 534 WI 535 WI 537 WI 538 WI 539 WI 
540 WI 541 WI 542 WI 543 WI 544 WI 545 WI 546 WI 547 WI 548 WI 549 WI 
550 MN 551 MN 553 MN 554 MN 555 MN 556 MN 557 MN 558 MN 559 MN 560 MN 
561 MN 562 MN 563 MN 564 MN 565 MN 566 MN 567 MN 570 SD 571 SD 572 SD 
573 SD 574 SD 575 SD 576 SD 577 SD 580 ND 581 ND 582 ND 583 ND 584 ND 
585 ND 586 ND 587 ND 588 ND 590 MT 591 MT 592 MT 593 MT 594 MT 595 MT 
596 MT 597 MT 598 MT 599 MT 600 IL 601 IL 602 IL 603 IL 604 IL 605 IL 
606 IL 607 IL 608 IL 609 IL 610 IL 611 IL 612 IL 613 IL 614 IL 615 IL 
616 IL 617 IL 618 IL 619 IL 620 IL 622 IL 623 IL 624 IL 625 IL 626 IL 
627 IL 628 IL 629 IL 630 MO 631 MO 633 MO 634 MO 635 MO 636 MO 637 MO 
638 MO 639 MO 640 MO 641 MO 644 MO 645 MO 646 MO 647 MO 648 MO 649 MO 
650 MO 651 MO 652 MO 653 MO 654 MO 655 MO 656 MO 657 MO 658 MO 660 KS 
661 KS 662 KS 664 KS 665 KS 666 KS 667 KS 668 KS 669 KS 670 KS 671 KS 
672 KS 673 KS 674 KS 675 KS 676 KS 677 KS 678 KS 679 KS 680 NE 681 NE 
683 NE 684 NE 685 NE 686 NE 687 NE 688 NE 689 NE 690 NE 691 NE 692 NE 
693 NE 700 LA 701 LA 703 LA 704 LA 705 LA 706 LA 707 LA 708 LA 710 LA 
711 LA 712 LA 713 LA 714 LA 716 AR 717 AR 718 AR 719 AR 720 AR 721 AR 
722 AR 723 AR 724 AR 725 AR 726 AR 727 AR 728 AR 729 AR 730 OK 731 OK 
733 TX 734 OK 735 OK 736 OK 737 OK 738 OK 739 OK 740 OK 741 OK 743 OK 
744 OK 745 OK 746 OK 747 OK 748 OK 749 OK 750 TX 751 TX 752 TX 753 TX 
754 TX 755 TX 756 TX 757 TX 758 TX 759 TX 760 TX 761 TX 762 TX 763 TX 
764 TX 765 TX 766 TX 767 TX 768 TX 769 TX 770 TX 772 TX 773 TX 774 TX 
775 TX 776 TX 777 TX 778 TX 779 TX 780 TX 781 TX 782 TX 783 TX 784 TX 
785 TX 786 TX 787 TX 788 TX 789 TX 790 TX 791 TX 792 TX 793 TX 794 TX 
795 TX 796 TX 797 TX 798 TX 799 TX 800 CO 801 CO 802 CO 803 CO 804 CO 
805 CO 806 CO 807 CO 808 CO 809 CO 810 CO 811 CO 812 CO 813 CO 814 CO 
815 CO 816 CO 820 WY 821 WY 822 WY 823 WY 824 WY 825 WY 826 WY 827 WY 
828 WY 829 WY 830 WY 831 WY 832 ID 833 ID 834 ID 835 ID 836 ID 837 ID 
838 ID 840 UT 841 UT 842 UT 843 UT 844 UT 845 UT 846 UT 847 UT 850 AZ 
852 AZ 853 AZ 855 AZ 856 AZ 857 AZ 859 AZ 860 AZ 863 AZ 864 AZ 865 AZ 
870 NM 871 NM 872 NM 873 NM 874 NM 875 NM 877 NM 878 NM 879 NM 880 NM 
881 NM 882 NM 883 NM 884 NM 885 TX 889 NV 890 NV 891 NV 893 NV 894 NV 
895 NV 897 NV 898 NV 900 CA 901 CA 902 CA 903 CA 904 CA 905 CA 906 CA 
907 CA 908 CA 910 CA 911 CA 912 CA 913 CA 914 CA 915 CA 916 CA 917 CA 
918 CA 919 CA 920 CA 921 CA 922 CA 923 CA 924 CA 925 CA 926 CA 927 CA 
928 CA 930 CA 931 CA 932 CA 933 CA 934 CA 935 CA 936 CA 937 CA 938 CA 
939 CA 940 CA 941 CA 942 CA 943 CA 944 CA 945 CA 946 CA 947 CA 948 CA 
949 CA 950 CA 951 CA 952 CA 953 CA 954 CA 955 CA 956 CA 957 CA 958 CA 
959 CA 960 CA 961 CA 962 AP 963 AP 964 AP 965 AP 966 AP 967 HI 968 HI 
969 GU 970 OR 971 OR 972 OR 973 OR 974 OR 975 OR 976 OR 977 OR 978 OR 
979 OR 980 WA 981 WA 982 WA 983 WA 984 WA 985 WA 986 WA 988 WA 989 WA 
990 WA 991 WA 992 WA 993 WA 994 WA 995 AK 996 AK 997 AK 998 AK 999 AK 
  );
%zipExceptions=qw(
83422 WY 96799 AS 96940 PW 96940 PW 96940 PW 96941 FM 96941 FM 96942 FM
96942 FM 96943 FM 96943 FM 96944 FM 96944 FM 96950 MP 96950 MP 96951 MP
96951 MP 96952 MP 96952 MP 96960 MH 96960 MH 96970 MH 96970 MH 06390 NY
);
}

##########################################################
##########################################################
##########################################################

sub payment {
print qq(<h2>FINAL PAYMENT WILL BE AVAILABLE WITH THE REGISTERED VERSION.</H2>
<H3><A HREF="http://www.webteacher.com/epowercart/register.html">Click here to register</A></H3>);
}


return false;


